///////////////////////////////////////////////////////////////////////////////
// Name:        nkern_net.h
// Purpose:     Header for nkernel network code
// Author:      Chad Rempp
// Modified by: Chad Rempp
// Created:     03-01-02
// Copyright:   (c) 2003 Chad Rempp
// Licence:     GNU Public License (hey it's what all my friends are doing)
///////////////////////////////////////////////////////////////////////////////
#ifndef NKERN_NET_H
#define NKERN_NET_H

#include <vector>
#include "nkernel/nkern_neuron.h"

//using namespace std;

///////////////////////////////////////////////////////////////////////////////
// Net class Declaration
///////////////////////////////////////////////////////////////////////////////
class Net{
private:
       int m_NumInputs;
       int m_NumOutputs;
       int m_NumHiddenLayers;
       int m_NumNeuronsPerLayer;
	   char name[256];
       vector<NeuronLayer> m_vecLayers;

public:
       Net();
       Net( int NumInputs,
                int NumOutputs,
                int NumHiddenLayers,
                int NumNeuronsPerLayer);
       void CreateNet();
	   void Net::ModNet(int NumInputs,
						int NumOutputs,
						int NumHiddenLayers,
						int NumNeuronsPerLayer);
       vector<float> GetWeights();
       int GetNumberOfWeights();
       void PutWeights(vector<float> weights);
       vector<float> Update(vector<float> inputs);
       inline float Sigmoid(float activation, float response);
};

#endif
